#include <stdio.h>

#include "Client.h"


int queue_empty = 1;


EMAIL queued_message;


CLIENT queued_client;


// outgoing emails leave the client at this point. here they are put in an outgoing queue instead.
void
mail (CLIENT client, EMAIL msg)
{
  puts("mail sent");
  incoming (getEmailTo(msg), msg);
}


// emails to be sent are processed by this method before beeing mailed.
void 
outgoing__wrappee__Keys (CLIENT client, EMAIL msg)
{
  setEmailFrom(msg, getClientId(client));
  mail(client, msg);
}
void 
outgoing__wrappee__Encrypt (CLIENT client, EMAIL msg)
{ 
  
  //encrypt
    int receiver = getEmailTo(msg);
    int pubkey = findPublicKey(client, receiver);
    if (pubkey) {
        setEmailEncryptionKey(msg, pubkey);
        setEmailIsEncrypted(msg, 1);
    }
  
  //end encrypt
  
  outgoing__wrappee__Keys(client, msg);
}



void
outgoing (CLIENT client, EMAIL msg)
{

    int size = getClientAddressBookSize(client);
    
    if (size) {
        sendToAddressBook(client, msg);
        puts("sending to alias in address book\n");
        int receiver = getEmailTo(msg);

        puts("sending to second receipient\n");
        int second = getClientAddressBookAddress(client, 1);
        setEmailTo(msg, second);
        outgoing__wrappee__Encrypt(client, msg);
        //incoming (second, msg);
        
        setEmailTo(msg, getClientAddressBookAddress(client, 0));
        outgoing__wrappee__Encrypt(client, msg);
    } else {
        outgoing__wrappee__Encrypt(client, msg);
    }  

}


// incoming emails reach the user at this point. here they are put in a mailbox.
void
deliver (CLIENT client, EMAIL msg)
{
   puts("mail delivered\n");   
}


// incoming emails are processed by this method before delivery.
void 
incoming__wrappee__AddressBook (CLIENT client, EMAIL msg)
{
  deliver (client, msg);
}


void 
incoming__wrappee__Forward (CLIENT client, EMAIL msg)
{  
  incoming__wrappee__AddressBook(client, msg);
  int fwreceiver = getClientForwardReceiver(client);
  if (fwreceiver) {
    
    setEmailTo(msg, fwreceiver);  
    forward (client, msg);
    
  }
}

void
incoming (CLIENT client, EMAIL msg)
{
  //decrypt
  
  int privkey = getClientPrivateKey(client);
  if (privkey) {
    
      if (isEncrypted(msg)
          && isKeyPairValid(getEmailEncryptionKey(msg), privkey))
        {
          setEmailIsEncrypted(msg, 0);
          setEmailEncryptionKey(msg, 0);
        }
  }  
  //end decrypt
  
  incoming__wrappee__Forward(client, msg);
}


CLIENT createClient(char *name) {
    CLIENT client = initClient();
    return client;
}


void
sendEmail (CLIENT sender, CLIENT receiver) 
{
  EMAIL email = createEmail (0, receiver);
  outgoing (sender, email);
  //incoming (receiver, email);
  
}


void
queue (CLIENT client, EMAIL msg)
{
    queue_empty = 0;
    queued_message = msg;
    queued_client = client;
}


int
is_queue_empty ()
{
    return queue_empty;
}


CLIENT
get_queued_client ()
{
    return queued_client;
}


EMAIL
get_queued_email ()
{
    return queued_message;
}

int
isKeyPairValid (int publicKey, int privateKey)
{
    printf("keypair valid %d %d", publicKey, privateKey);
  if (!publicKey || !privateKey)
    return 0;
  return privateKey == publicKey;
}


void
generateKeyPair (CLIENT client, int seed)
{
    setClientPrivateKey(client, seed);
}

void
sendToAddressBook (CLIENT client, EMAIL msg)
{

}

void
forward (CLIENT client, EMAIL msg)
{  
  puts("Forwarding message.\n");  
  printMail(msg);
  queue(client, msg);
 
}
