from splverifier.api.config import PATHS
from splverifier.api.fs import *
import os

def cilly(source_dir, target_file, fileset=None, excludes=None):
    tmpfs = FileStore(PATHS.cil.tmpdir).clear().create()
    FileStore(source_dir).copycontents(tmpfs.get())
    savetmps_dir = tmpfs.create('save').get('save')
    if fileset is None:
        inputfiles = [item for item in os.listdir(source_dir) if item.endswith('.c')]
        if excludes is not None:
            inputfiles = [f for f in inputfiles if not f in excludes]
    else:
        inputfiles = fileset

    
    cmdline = ' '.join([
            'cd %s;%s --dosimplify --printCilAsIs --save-temps=%s',
            '--domakeCFG --dosimpleMem --merge'
        ] + inputfiles) % (
            tmpfs.get(),
            PATHS.cil.cilly_bin,
            savetmps_dir,
        )

    timer = Timer().start()
    system(cmdline)
    timer.stop()
    
    mv(tmpfs.get('save/a.cil.c'), target_file)
    return timer.elapsed
    
