from splverifier.api.config import PATHS
from splverifier.api.fs import FileStore, system, Timer, nameonly

def introduce_spec():
    spec = SPECIFICATION + '.spec'
    feature = 'Encrypt'    
    absspec = os.path.join(feature_dir, feature, spec)
    for i in TOCHECK:
        local('cp %s %s'% (absspec, os.path.join(targetdir, INTERACTION, i)))


def _fstcomp(expression, containment_hierarchy, target_dir, lift=False, feature_model=None, assume_features=[]):

    if lift and not feature_model:
        raise Exception('A feature model needs to be specified.')
    
    if lift:
        lifting_args = '--lift'
    else:
        lifting_args = ''
        
    feature_fs = FileStore(containment_hierarchy)
    composed_dir = nameonly(expression)
    if feature_fs.exists(composed_dir):
        raise Exception('There is already a dir/file at %s' % (feature_fs.get(composed_dir)))
        
    timer = Timer().start()
    system('java -jar %s --expression %s --base-directory %s %s > /dev/null' % (
        PATHS.featurehouse_jar,
        expression,
        containment_hierarchy,
        lifting_args,
    ))
    timer.stop()
    
    feature_fs.get_fs(composed_dir).moveto(target_dir)
    
    #set assumed features to 1
    if assume_features:
        fp = open(target_dir + '/featureselect.c')
        featureselect_c = fp.read()
        fp.close()
        fp = open(target_dir + '/featureselect.c', 'w')
        for assumed in assume_features:
            featureselect_c = featureselect_c.replace(
                '__SELECTED_FEATURE_%s = select_one();' % assumed,
                '__SELECTED_FEATURE_%s = 1;' % assumed
            )
        fp.write(featureselect_c)
        fp.close()
    
    return timer.elapsed


def compose(expression, containment_hierarchy, target_dir):
    return _fstcomp(expression, containment_hierarchy, target_dir)
    
def encode_variability(expression, containment_hierarchy, target_dir, feature_model, assume_features=[]):
    return _fstcomp(
        expression, 
        containment_hierarchy, 
        target_dir, 
        lift = True, 
        feature_model = feature_model,
        assume_features = assume_features
    )

def get_features_from_expression(expfile):
    return [x for x in open(expfile, 'r').read().split() if x.strip()]


class FSTComposer(object):
    pass
#    def compose(self, spl, feature_selection, target_dir):
#        

